#!/bin/bash


#launch job in parralel
MAX_JOBS=$(( $(nproc) -4 ))   # Maximum parallel jobs
SEMAPHORE="job_semaphore"

# Create a named pipe (FIFO) for job control
mkfifo $SEMAPHORE
exec 3<> $SEMAPHORE
rm $SEMAPHORE

# Pre-fill the semaphore with tokens equal to MAX_JOBS
for ((i=0; i<MAX_JOBS; i++)); do
    echo "" >&3
done


for run in {245..252}; do
    read -u 3  # Wait for an available slot
    {
        root -l -q "./CorrectionZ.C(\"../../../../root/analysis/Run"$run"AoQ_test.root\")" 
        echo "" >&3  # Release the slot
    } & 
done

wait

exec 3>&- #close semaphore 
# Define output file name
output_file="Output/histo_merged.root"

# Initialize an empty list of files
files=""

# Loop through the run numbers
for run in {245..252}; do
    filename="Output/histo_${run}.root"

    # Check if the file exists before adding it
    if [[ -f "$filename" ]]; then
        files+=" $filename"
    else
        echo "Warning: $filename not found, skipping."
    fi
done

# Perform hadd only if there are files
if [[ -n "$files" ]]; then
    echo "Merging files into $output_file..."
    hadd "$output_file" $files
else
    echo "No valid files found. Nothing to merge."
fi
